package lab07;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.URISyntaxException;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;

import lombok.extern.log4j.Log4j2;

@Log4j2
public class Main {
	public static void main(String[] args) throws IOException, URISyntaxException {
		int port = 8000;
		String basePathName = "..";
		Path basePath = Paths.get(basePathName).toRealPath();
		log.info("Started server on http://localhost:{} with base path {} and on http://localhost:{}", port, basePath, port + 1);
		HttpHandler handler = new HttpHandler(Paths.get(basePathName));
		try(ServerSocketChannel ssc = ServerSocketChannel.open();ServerSocketChannel ssc2 = ServerSocketChannel.open()){
			ssc.bind(new InetSocketAddress(port));
			ssc.configureBlocking(false);
			
			ssc2.bind(new InetSocketAddress(port + 1));
			ssc2.configureBlocking(false);
			
			//task #4 - handle two channels with selector 
			try(Selector selector = Selector.open())
			{
				ssc.register(selector, SelectionKey.OP_ACCEPT);
				ssc2.register(selector, SelectionKey.OP_ACCEPT);
				
				while(true) {
					if(0 == selector.select()) {
						break;
					}
					Iterator<SelectionKey> keys = selector.selectedKeys().iterator();
					while (keys.hasNext()) {
						SelectionKey key = keys.next();
						if (key.interestOps() == SelectionKey.OP_ACCEPT) {
							if (key.channel() == ssc) {
								handler.handle(ssc.accept());
							}
							
							if (key.channel() == ssc2) {
								handler.handleObserverChannel(ssc2.accept());
							}
						}
						keys.remove();
					}
				}
			}
		}
		
	}
}
